unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, DB, DBCtrls, DBTables, cad;

type
  TMainForm = class(TForm)
    Table1: TTable;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Table1Name: TStringField;
    Table1LastUpdate: TDateTimeField;
    Table1Draw: TBlobField;
    Image1: TImage;
    lblName: TLabel;
    lblLastUpdate: TLabel;
    lblDraw: TLabel;
    Panel1: TPanel;
    edtName: TEdit;
    edtLastUpdate: TEdit;
    MyCAD1: TMyCAD;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Table1AfterOpen(DataSet: TDataSet);
    procedure DBNavigator1Click(Sender: TObject; Button: TNavigateBtn);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadDraw;
  end;

var
  MainForm: TMainForm;

implementation

uses EditFrm;

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Table1.Open;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Table1.Close;
end;

procedure TMainForm.LoadDraw;
var
  ms:TMemoryStream;
begin
  ms:=TMemoryStream.Create;
  edtName.Text:=Table1.FieldByName('Name').AsString;
  edtLastUpdate.Text:=Table1.FieldByName('LastUpdate').AsString;
  Table1Draw.SaveToStream(ms);
  if ms.Size>0 then
    MyCAD1.LoadFromStream(ms);
  ms.Free;
end;

procedure TMainForm.Table1AfterOpen(DataSet: TDataSet);
begin
  LoadDraw;
end;

procedure TMainForm.DBNavigator1Click(Sender: TObject;
  Button: TNavigateBtn);
var
  ms:TMemoryStream;
begin
  if (Button=nbFirst) or
    (Button=nbPrior) or
    (Button=nbNext) or
    (Button=nbLast) or
    (Button=nbDelete) or
    (Button=nbRefresh) then
    LoadDraw;
  if (Button=nbEdit) then
  begin
    EditForm.CADEdit.Tag:=0;
    ms:=TMemoryStream.Create;
    EditForm.edtName.Text:=Table1.FieldByName('Name').AsString;
    Table1Draw.SaveToStream(ms);
    if ms.Size>0 then
      EditForm.CADEdit.LoadFromStream(ms);
    ms.Free;
    EditForm.ShowModal;
  end;

  if (Button=nbInsert) then
  begin
    EditForm.CADEdit.Tag:=1;
    EditForm.CADEdit.DeleteAllShapes;
    EditForm.edtName.Text:='Please input the draw name.';
    EditForm.ShowModal;
  end;
end;

end.
